require 'extensions/object'

module Ach
  class Creator
    
    def self.block_count(filelines)
      filelines = ((filelines.to_f+1)/10)
      return filelines.round
    end
    
    def self.write_header(content,ach_filename)
        ach_file = File.new(ach_filename.path,"a+")
        ach_file.puts(content)
        ach_file.close
      end

    def self.mod_operation(routing_num_mod)
      @rtnum = routing_num_mod.to_s.split(//)
      @multiply = Array.new
      @multiply.push(@rtnum[0].to_i * 3)
      @multiply.push(@rtnum[1].to_i * 7)
      @multiply.push(@rtnum[2].to_i * 1)
      @multiply.push(@rtnum[3].to_i * 3)
      @multiply.push(@rtnum[4].to_i * 7)
      @multiply.push(@rtnum[5].to_i * 1)
      @multiply.push(@rtnum[6].to_i * 3)
      @multiply.push(@rtnum[7].to_i * 7)
      @add = (@multiply[0] + @multiply[1] + @multiply[2] + @multiply[3] + @multiply[4] + @multiply[5] + @multiply[6] + @multiply[7])
      if (@add % 10) == 0
      return (@add % 10)
      else
      return ((@add + 10 - (@add % 10)) - @add)
      end
    end

    def self.create_file(structure,iterator,ach_filename)
      # records = iterator.get_entry_details

      @create_ach_file = File.new(ach_filename,"w+")
      @create_ach_file.close

      @addenda_count = 1
      @addenda_record_count = Array.new
      @trace_number = 0
      @trace_number_counter = Array.new
      @sequence_number = 1
      @entry_hash_collector = Array.new

      @filecontrol_debits = []
      @filecontrol_credits = []
      @entrydetails_counter= []

      SecurityHeaderRecord.new(
      :security_header => structure[:bank_params][:security_header],
      :write_to_file => @create_ach_file)

      file_header_obj = FileHeaderRecord.new(
      :record_type => "1",
      :priority_code => "01",
      :record_size => "094",
      :blocking_factor => "10",
      :file_creation_date => structure[:file_header_record][:file_creation_date],
      :file_creation_time => structure[:file_header_record][:file_creation_time],
      :format_code => "1",
      :file_id => structure[:bank_params][:file_id_yml],
      :bank_name => structure[:bank_params][:name],
      :company_name => structure[:file_header_record][:company_name],
      :file_id_modifier => structure[:file_header_record][:file_id_modifier],
      :origination_bank => "WELLS FARGO",
      :wellsfargo_routing_number => " 091000019",
      :write_to_file => @create_ach_file)

      structure[:batch_header_records].each_with_index do |bhr,index|
        @batch_debit_collector = []
        @batch_credit_collector = []

        @batch_header_obj = BatchHeaderRecord.new(
        :record_type => '5',
        :service_class_code => bhr[:service_class_code],
        :company_name => bhr[:company_name],
        :company_discretionary_data => (bhr[:company_discretionary_data] ? bhr[:company_discretionary_data] : nil),
        :company_id => structure[:bank_params][:company_id_yml],
        :standard_entry_class_code => bhr[:standard_entry_class_code],
        :company_entry_description => bhr[:company_entry_description],
        :company_descriptive_date => (bhr[:company_descriptive_date] ? bhr[:company_descriptive_date] : nil),
        :effective_entry_date => bhr[:effective_entry_date],
        :batch_number => (index+1).to_s,
        :originator_status_code => "1",
        :wellsfargo_routing_number => structure[:bank_params][:routing_num_originating_dfi_yml],
        :write_to_file => @create_ach_file)

        #chunk which supports creation of entry_detail db entries. Send in batch db entry's id
        @entry_details = iterator.get_entry_details
        @entrydetails_counter << @entry_details.size.to_i
        @entry_details.each do |i|
          @receiving_dfi_routing_num = i[:receiving_dfi_routing_number]
          rt_num_check_mod =  mod_operation(@receiving_dfi_routing_num)
          @trace_number_counter.push @trace_number
          @trace_number+=1

          entry_detail = EntryDetailRecord.new(
          :transaction_code => i[:transaction_code],
          :receiving_dfi_routing_num => @receiving_dfi_routing_num,
          :rt_num_check => rt_num_check_mod,
          :receiving_dfi_acc_num => i[:receiving_dfi_account_number],
          :amount => i[:amount].to_s.sub(/[.]/,''),
          :individual_id => i[:individual_id],
          :individual_name => (i[:individual_name].nil? ? "" : i[:individual_name]),
          :routing_number => structure[:bank_params][:routing_num_originating_dfi_yml],
          :trace_number => @trace_number,
          :settlement_id => i.respond_to?(:settlement_id) ? i[:settlement_id] : nil,
          :loan_payment_id => i.respond_to?(:loan_payment_id) ? i[:loan_payment_id] : nil,
          :write_to_file => @create_ach_file,
          :db_entry_amount => i[:amount]) #amount for storing the ach_@entry_details_table

          if (i[:transaction_code]=="22" or i[:transaction_code]=="32")
          @batch_credit_collector.push i[:amount].to_f
          else
          @batch_debit_collector.push i[:amount].to_f
          end

          @rdfi_rtn_split = @receiving_dfi_routing_num.slice(0..7)
          @rdfi_rtn_split.each {|i| @entry_hash_collector.push i.to_i}
          @addenda_count+=1
          @addenda_record_count.push @addenda_count
        end
        #TODO: REPLACE addendacount!!! @entry_details[:records].size
        batch_control = BatchControlRecord.new(
        :service_class_code => bhr[:service_class_code],
        :addenda_count => @entry_details.size,
        :entry_hash => @entry_hash_collector.inject(0) {|sum,i| sum+i},
        :total_debits => @batch_debit_collector.inject(0) {|sum,i| sum+i}.to_s.sub(/[.]/,''),
        :total_credits => @batch_credit_collector.inject(0) {|sum,i| sum+i}.to_s.sub(/[.]/,''),
        :company_id => structure[:bank_params][:company_id_yml],
        :routing_num => structure[:bank_params][:routing_num_originating_dfi_yml],
        :batch_number => (index+1).to_s,
        :write_to_file => @create_ach_file)
        @batch_credit_collector.each {|x| @filecontrol_credits << x}
        @batch_debit_collector.each {|x| @filecontrol_debits << x}
      end

      #      rt_num_check_mod =  mod_operation(structure[:bank_params][:receiving_dfi_routing_num])

      @count_filelines = %x(wc -l #{"#{ach_filename}"}).split.first.to_i
      @block_count = block_count(@count_filelines)
      #((@trace_number_counter.last-1)+(@addenda_record_count.last-1)), #TODO: REPLACE THIS!!! @entry_details[:records].size
      file_control = FileControlRecord.new(
                                  :batch_count => structure[:batch_header_records].size,
                                  :block_count => @block_count,
                                  :entry_addenda => @entrydetails_counter.inject(0) {|sum,i| sum+i},
                                  :entry_hash_total => @entry_hash_collector.inject(0) {|sum,i| sum+i},
                                  :total_debits => @filecontrol_debits.inject(0) {|sum,i| sum+i}.to_s.sub(/[.]/,''),
                                  :total_credits => @filecontrol_credits.inject(0) {|sum,i| sum+i}.to_s.sub(/[.]/,''),
                                  :write_to_file => @create_ach_file)
    end

  end

  class SecurityHeaderRecord
    attr_accessor :security_header
    def initialize(options={})
      @security_header = options[:security_header]
      @write_to_file = options[:write_to_file]
      encode
    end

    protected

    def encode
      begin
        file = @security_header.strip
        Ach::Creator.write_header(file,@write_to_file)
      rescue Exception => ex
        puts "Exception while writing ach file -- #{ex.class} #{ex.message} #{ex.backtrace.pp_s}"
      end
    end
  end

  class FileHeaderRecord
    attr_accessor :record_type, :priority_code, :routing_number, :file_id, :record_size, :file_id_modifier
    attr_accessor :blocking_factor, :format_code, :origination_bank, :bank,:company_name,:bank_name,:call_encode
    attr_accessor :file_creation_date,:file_creation_time
    def initialize(options={})
      @record_type = options[:record_type]
      @priority_code = options[:priority_code]
      @routing_number = options[:routing_number]
      @file_id = options[:file_id]
      @record_size = options[:record_size]
      @blocking_factor = options[:blocking_factor]
      @file_creation_date = options[:file_creation_date]
      @file_creation_time = options[:file_creation_time]
      @format_code = options[:format_code]
      @company_name = options[:company_name]
      @bank_name = options[:bank_name]
      @write_to_file = options[:write_to_file]
      @file_id_modifier = options[:file_id_modifier]
      @origination_bank = options[:origination_bank]
      @wellsfargo_routing_number = options[:wellsfargo_routing_number]
      @call_encode = encode
    end

    def self.decode(record,processor)
      # change method sig to decode(record,processor)
      file_header = CustomOrderedHash.new
      file_header.insert(:record_type,record[0].chr)
      file_header.insert(:priority_code,record[1,2])
      file_header.insert(:routing_number,record[4,9])
      file_header.insert(:file_id,record[13,10])
      file_header.insert(:file_creation_date, record[23,6])
      file_header.insert(:file_creation_time,record[29,4])
      file_header.insert(:file_id_mod,record[33,1])
      file_header.insert(:record_size ,record[34,3])
      file_header.insert(:blocking_factor, record[37,2])
      file_header.insert(:format_code, record[39,1])
      file_header.insert(:origination_bank, record[40,23])
      file_header.insert(:company_name,record[63,23])
      processor.process(file_header)
    #        log_dump ="#{@record_type}#{@priority_code}#{@routing_number}#{@file_id}#{@file_creation_time}#{@file_id_mod}#{@record_size}#{@blocking_factor}#{@format_code}#{@origination_bank}#{@company_name}"
    #        Batch::PartnersAchGenerateLog::AchLogGenerator.log_return_process(log_dump)
    end

    protected

    def encode
      begin
      #          file = "#{@record_type}#{@priority_code} #{@routing_number}#{@file_id}#{file_creation_date.strftime('%y%m%d')}#{file_creation_time.strftime('%H%M')}#{@file_id_modifier}094#{@blocking_factor}#{@format_code}WELLS FARGO            Billfloat                      "
        file = "#{@record_type}#{@priority_code}#{@wellsfargo_routing_number}#{@file_id}#{@file_creation_date.strftime('%y%m%d')}#{@file_creation_time.strftime('%H%M')}#{@file_id_modifier}#{@record_size}#{@blocking_factor}#{@format_code}#{@origination_bank}            #{@company_name}                      "
        Ach::Creator.write_header(file,@write_to_file)
      rescue Exception => ex
        puts "Exception writing ach file -- #{ex.message} #{ex.backtrace.pp_s}"
      end
    end

  end

  class BatchHeaderRecord
    attr_accessor :record_type, :service_class_code, :sec_code, :company_entry_desc,:company_name
    attr_accessor :effective_entry_date, :batch_number, :company_id, :originator_status_code, :routing_number,:company_descriptive_date
    attr_accessor :company_discretionary_data,:company_entry_description,:company_desc_date,:settlement_date,:ach_file_id,:call_encode
    def initialize(options={})
      @record_type = options[:record_type]
      @service_class_code = options[:service_class_code]
      @company_name = options[:company_name]
      @company_discretionary_data = options[:company_discretionary_data]
      @company_id = options[:company_id]
      @sec_code = options[:standard_entry_class_code]
      @company_entry_desc = options[:company_entry_description]
      @company_desc_date = options[:company_descriptive_date]
      @posting_date = options[:effective_entry_date]
      @batch_number = options[:batch_number]
      @originator_status_code = options[:originator_status_code]
      @wellsfargo_routing_number = options[:wellsfargo_routing_number]
      @ach_file_id = options[:ach_file_id]
      @write_to_file = options[:write_to_file]
      @call_encode = encode
    end

    def self.decode(record,processor)
      batch_header = CustomOrderedHash.new
      batch_header.insert(:record_type,record[0].chr)
      batch_header.insert(:@service_class_code,record[1,3])
      batch_header.insert(:company_name,record[4,16])
      batch_header.insert(:company_disc_data,record[20,20])
      batch_header.insert(:company_id,record[40,10])
      batch_header.insert(:sec_code,record[50,3])
      batch_header.insert(:company_entry_desc,record[53,10])
      batch_header.insert(:company_desc_date,record[63,6])
      batch_header.insert(:posting_date, record[69,6])
      batch_header.insert(:settlement_date,record[75,3])
      batch_header.insert(:originator_status_code,record[78,1])
      batch_header.insert(:routing_number,record[79,8])
      batch_header.insert(:batch_number,record[87,7])
      processor.process(batch_header)
    end

    protected

    def encode
      begin
        file = @record_type
        file << @service_class_code
        file << @company_name.ljust(16)
        file << (@company_discretionary_data ? @company_discretionary_data.ljust(20) : "".ljust(20))
        file << @company_id.to_s.ljust(10)
        file << @sec_code.upcase.ljust(3)
        file << @company_entry_desc.ljust(10)
        file << (@company_desc_date ? @company_desc_date.ljust(6) : "".ljust(6))
        # file << (Date.today-1).strftime("%m%d%y").ljust(6)                       # Company Descriptive Date
        if @posting_date.is_a?(String)
          file << Date.parse(@posting_date).strftime("%y%m%d").to_s.ljust(6)
        else
          file << @posting_date.strftime("%y%m%d").to_s.ljust(6)
        end
        file << "".ljust(3)                                                 # Settlement date - leave blank
        file << @originator_status_code.to_s.ljust(1)
        file << @wellsfargo_routing_number.to_s.ljust(8)
        @batch_number = "0000000000000"+@batch_number.to_s
        file << @batch_number[-7,7] #added one number and minus from batch num digit count
        Ach::Creator.write_header(file,@write_to_file)
        # batch_header_entry.reload
        # return batch_header_entry.id
      rescue Exception => ex
        puts "Exception while writing ach file -- #{ex.class} #{ex.message} #{ex.backtrace.pp_s}"
      end
    end

  end

  class EntryDetailRecord
    attr_accessor :record_type, :transaction_code, :routing_number_check, :receiving_dfi_acc_num,:rt_num_check
    attr_accessor :amount, :individual_id,:receiving_dfi_routing_num,:individual_id,:individual_name
    attr_accessor :routing_number, :trace_number,:disc_data,:addenda_record_indicator,:ach_batch_id,:settlement_id,:db_entry_amount
    def initialize(options = {})
      @record_type = '6'
      @transaction_code = options[:transaction_code]
      @receiving_dfi_routing_num = options[:receiving_dfi_routing_num]
      @receiving_dfi_acc_num = options[:receiving_dfi_acc_num]
      @rt_num_check = options[:rt_num_check]
      @amount = options[:amount]
      @individual_id = options[:individual_id]
      @individual_name = options[:individual_name]
      @routing_number = options[:routing_number]
      @trace_number = options[:trace_number]
      @ach_batch_id = options[:ach_batch_id]
      @settlement_id = options[:settlement_id]
      @db_entry_amount = options[:db_entry_amount]
      @write_to_file = options[:write_to_file]
      encode
    end

    def self.decode(record,processor)
      entry_detail = CustomOrderedHash.new
      entry_detail.insert(:record_type,record[0].chr)
      entry_detail.insert(:transaction_code, record[1,2])
      entry_detail.insert(:receiving_dfi_routing_num,record[3,8])
      entry_detail.insert(:rt_num_check,record[11,1])
      entry_detail.insert(:receiving_dfi_acc_num,record[12,17])
      entry_detail.insert(:amount,record[29,10])
      entry_detail.insert(:individual_id,record[39,15])
      entry_detail.insert(:individual_name,record[54,22])
      entry_detail.insert(:disc_data,record[76,2])
      entry_detail.insert(:addenda_record_indicator,record[78,1])
      entry_detail.insert(:@trace_number,record[79,15])
      processor.process(entry_detail)
    end

    protected

    def encode
      begin
        file = @record_type
        file << @transaction_code
        file << @receiving_dfi_routing_num.to_s.split(//).first(8).to_s
        file << @rt_num_check.to_s
        file << @receiving_dfi_acc_num.to_s.split(//).last(17).to_s.ljust(17)
        file << @amount.rjust(10,"0")
        file << @individual_id.to_s.ljust(15)
        file << @individual_name.slice(0..21).ljust(22)
        file << "".ljust(2)       #9. discretionary data
        file << "0"
        @trace_number = "000000000000000"+@trace_number.to_s
        file << @routing_number+@trace_number[-7,7]
        Ach::Creator.write_header(file,@write_to_file)
      rescue Exception => ex
        puts "Exception while writing ach file -- #{ex.class} #{ex.message} #{ex.backtrace.pp_s}"
      end
    end

  end

  class BatchControlRecord
    attr_accessor :record_type, :service_class_code, :addenda_count,:entry_hash,:company_id
    attr_accessor :total_debits,:total_credits,:batch_number,:routing_num,:msg_authentication_code
    def initialize(options={})
      @record_type = '8'
      @service_class_code = options[:service_class_code]
      @addenda_count = options[:addenda_count]
      @entry_hash=options[:entry_hash]
      @total_debits = options[:total_debits]
      @total_credits = options[:total_credits]
      @company_id = options[:company_id]
      @routing_num = options[:routing_num]
      @batch_number = options[:batch_number]
      @write_to_file = options[:write_to_file]
      encode
    end

    def self.decode(record,processor)
      batch_control = CustomOrderedHash.new
      batch_control.insert(:record_type,record[0].chr)
      batch_control.insert(:service_class_code,record[1,3])
      batch_control.insert(:addenda_count,record[4,6])
      batch_control.insert(:entry_hash,record[10,10])
      batch_control.insert(:total_debits, record[20,12])
      batch_control.insert(:total_credits, record[32,12])
      batch_control.insert(:company_id, record[44,10])
      batch_control.insert(:msg_authentication_code, record[54,19])
      batch_control.insert(:reserved,record[73,6])
      batch_control.insert(:routing_num, record[79,8])
      batch_control.insert(:batch_number, record[87,7])
      processor.process(batch_control)
    end

    protected

    def encode
      begin
        file = @record_type
        file << @service_class_code.to_s
        @addenda_digit_count = @addenda_count.to_s.split(//)
        if @addenda_digit_count.size > 1
          file << @addenda_count.to_s.rjust(5,"0")
        else
          file << @addenda_count.to_s.rjust(6,"0")
        end
        file << @entry_hash.to_s.rjust(10,"0")
        file << @total_debits.rjust(12,"0")
        file << @total_credits.rjust(12,"0")
        file << @company_id.to_s
        file << "".ljust(19)
        file << "".ljust(6)
        file << @routing_num
        @batch_number = "0000000000000" + @batch_number.to_s
        file << @batch_number[-7,7]
        Ach::Creator.write_header(file,@write_to_file)
      rescue Exception => ex
        puts "Exception while writing ach file -- #{ex.class} #{ex.message} #{ex.backtrace.pp_s}"
      end
    end

  end

  class FileControlRecord
    attr_accessor :record_type,:batch_count,:block_count,:entry_addenda
    attr_accessor :entry_hash_total,:total_debits,:total_credits
    def initialize(options={})
      @record_type = '9'
      @batch_count = options[:batch_count]
      @block_count = options[:block_count]
      @entry_addenda = options[:entry_addenda]
      @entry_hash_total = options[:entry_hash_total]
      @total_debits = options[:total_debits]
      @total_credits = options[:total_credits]
      @write_to_file = options[:write_to_file]
      encode
    end

    def self.decode(record,processor)
      file_control = CustomOrderedHash.new
      file_control.insert(:record_type,record[0].chr)
      file_control.insert(:batch_count, record[1,6])
      file_control.insert(:block_count, record[7,6])
      file_control.insert(:entry_addenda, record[13,8])
      file_control.insert(:entry_hash_total, record[21,10])
      file_control.insert(:total_debits, record[31,12])
      file_control.insert(:total_credits, record[43,12])
      processor.process(file_control)
    end

    protected

    def encode
      begin
        file = @record_type
        file << @batch_count.to_s.rjust(6,"0")
        file << @block_count.to_s.rjust(6,"0")
        file << @entry_addenda.to_s.rjust(8,"0")
        @entry_hash_total_digit_count = @entry_hash_total.to_s.split(//)
        if @entry_hash_total_digit_count.size >= 10
          file << @entry_hash_total.to_s.slice(1..10).rjust(10,"0")
        else
          file << @entry_hash_total.to_s.slice(0..10).rjust(10,"0")
        end
        file << @total_debits.rjust(12,"0")
        file << @total_credits.rjust(12,"0")
        file << "".ljust(39)
        Ach::Creator.write_header(file,@write_to_file)
      rescue Exception => ex
        puts "\n Exception writing ACH file -- #{ex}"
      end
    end

  end

end
